_ALLREPOS/jondeame/config/routes.rb
require 'sidekiq/web'

Catarse::Application.routes.draw do

  devise_for :users, path: '',
    path_names:   { sign_in: :login, sign_out: :logout, sign_up: :sign_up }, 
    controllers:  { omniauth_callbacks: :omniauth_callbacks, passwords: :passwords }

  devise_scope :user do
    post '/sign_up', to: 'devise/registrations#create', as: :sign_up
  end

  match '/thank_you' => "static#thank_you"

  check_user_admin = lambda { |request| request.env["warden"].authenticate? and request.env['warden'].user.admin }

  filter :locale, exclude: /\/auth\//

  # Mountable engines
  constraints check_user_admin do
    mount Sidekiq::Web => '/sidekiq'
  end

  mount CatarsePaypalExpress::Engine => "/", as: :catarse_paypal_express
  mount CatarseMoip::Engine => "/", as: :catarse_moip

  # Non production routes
  if Rails.env.development?
    resources :emails, only: [ :index ]
  end

  # Channels
  constraints subdomain: 'asas' do
    namespace :channels, path: '' do
      namespace :adm do
        resources :projects, only: [ :index, :update] do
          member do
            put 'approve'
            put 'reject'
            put 'push_to_draft'
          end
        end
      end
      get '/', to: 'profiles#show', as: :profile
      get '/how-it-works', to: 'profiles#how_it_works', as: :about
      resources :projects, only: [:new, :create, :show] do
        collection do
          get 'video'
        end
      end
      resources :channels_subscribers, only: [:index, :create, :destroy]
    end
  end

  # Root path should be after channel constraints
  root to: 'projects#index'

  # Static Pages
  get '/sitemap',               to: 'static#sitemap',             as: :sitemap
  get '/guidelines',            to: 'static#guidelines',          as: :guidelines
  get "/guidelines_tips",       to: "static#guidelines_tips",     as: :guidelines_tips
  get "/guidelines_backers",    to: "static#guidelines_backers",  as: :guidelines_backers
  get "/guidelines_start",      to: "static#guidelines_start",    as: :guidelines_start
  get "/about",                 to: "static#about",               as: :about


  match "/explore" => "explore#index", as: :explore
  match "/explore#:quick" => "explore#index", as: :explore_quick
  match "/credits" => "credits#index", as: :credits

  match "/reward/:id" => "rewards#show", as: :reward
  resources :posts, only: [:index, :create]

  namespace :reports do
    resources :backer_reports_for_project_owners, only: [:index]
  end

  resources :projects do
    resources :updates, controller: 'projects/updates', only: [ :index, :create, :destroy ]
    resources :rewards, only: [ :index, :create, :update, :destroy, :new, :edit ] do
      member do
        post 'sort'
      end
    end
    resources :backers, controller: 'projects/backers', only: [ :index, :show, :new, :create ] do
      member do
        match 'credits_checkout'
        post 'update_info'
      end
    end
    collection do
      get 'video'
    end
    member do
      put 'pay'
      get 'embed'
      get 'video_embed'
      get 'embed_panel'
    end
  end
  resources :users do
    resources :projects, controller: 'users/projects', only: [ :index ]
    collection do
      get :uservoice_gadget
    end
    resources :backers, controller: 'users/backers', only: [:index] do
      member do
        match :request_refund
      end
    end

    resources :unsubscribes, only: [:create]
    member do
      get 'projects'
      get 'credits'
      put 'unsubscribe_update'
      put 'update_email'
      put 'update_password'
    end
  end
  # match "/users/:id/request_refund/:back_id" => 'users#request_refund'

  resources :credits, only: [:index] do
    collection do
      get 'buy'
      post 'refund'
    end
  end

  namespace :adm do
    resources :projects, only: [ :index, :update, :destroy ] do
      member do
        put 'approve'
        put 'reject'
        put 'push_to_draft'
      end
    end

    resources :statistics, only: [ :index ]
    resources :financials, only: [ :index ]

    resources :backers, only: [ :index, :update ] do
      member do
        put 'confirm'
        put 'pendent'
        put 'change_reward'
        put 'refund'
        put 'hide'
        put 'cancel'
        put 'push_to_trash'
      end
    end
    resources :users, only: [ :index ]

    namespace :reports do
      resources :backer_reports, only: [ :index ]
    end
  end

  match "/mudancadelogin" => "users#set_email", as: :set_email_users
  match "/:permalink" => "projects#show", as: :project_by_slug

end

_ALLREPOS/jondeame/app/controllers/adm/backers_controller.rb
class Adm::BackersController < Adm::BaseController
  menu I18n.t("adm.backers.index.menu") => Rails.application.routes.url_helpers.adm_backers_path
  has_scope :by_user_id, :by_key, :user_name_contains, :project_name_contains, :confirmed, :credits, :requested_refund, :refunded,
    :by_state, :by_value
  has_scope :between_values, using: [ :start_at, :ends_at ], allow_blank: true
  has_scope :pending_to_refund do |controller, scope, value|
    if value.present?
      scope.pending_to_refund
    else
      scope
    end
  end
  before_filter :set_title

  def self.backer_actions
    %w[confirm pendent refund hide cancel push_to_trash].each do |action|
      define_method action do
        resource.send(action)
        flash[:notice] = I18n.t("adm.backers.messages.successful.#{action}")
        redirect_to adm_backers_path(params[:local_params])
      end
    end
  end
  backer_actions

  def change_reward
    resource.change_reward! params[:reward_id]
    flash[:notice] = I18n.t('adm.backers.messages.successful.change_reward')
    redirect_to adm_backers_path(params[:local_params])
  end

  protected
  def set_title
    @title = t("adm.backers.index.title")
  end

  def collection
    @backers = apply_scopes(end_of_association_chain).not_deleted.order("backers.created_at DESC").page(params[:page])
  end
end

_ALLREPOS/jondeame/app/controllers/adm/base_controller.rb
class Adm::BaseController < ApplicationController
  inherit_resources
  before_filter do
    authorize! :manage, resource_class  
  end

  @@menu_items = {}
  cattr_accessor :menu_items

  def self.menu menu=nil
    if menu
      self.menu_items.merge! menu
    else
      self.menu_items
    end
  end

  def update
    update! do |format|
      if resource.errors.empty?
        format.json { respond_with_bip(resource) }
      else
        format.html { render action: "edit" }
        format.json { respond_with_bip(resource) }
      end
    end
  end

  def current_ability
    controller_name_segments = params[:controller].split('/')
    controller_name_segments.pop
    controller_namespace = controller_name_segments.join('/').camelize
    @current_ability ||= Ability.new(current_user, { namespace: controller_namespace })
  end


end

_ALLREPOS/jondeame/app/controllers/adm/financials_controller.rb
class Adm::FinancialsController < Adm::BaseController
  require 'csv'
  inherit_resources
  defaults  resource_class: Project, collection_name: 'projects', instance_name: 'project'
  menu I18n.t("adm.financials.index.menu") => Rails.application.routes.url_helpers.adm_financials_path
  has_scope :by_permalink, :name_contains, :user_name_contains, :financial, :by_state, :by_progress
  has_scope :between_expires_at, using: [ :start_at, :ends_at ], allow_blank: true

  actions :index

  def projects
    @search = apply_scopes(Project).includes(:user).order("CASE state WHEN 'successful' THEN 1 WHEN 'waiting_funds' THEN 2 ELSE 3 END, (projects.expires_at)::date DESc")
  end

  def collection
    @projects = projects.page(params[:page])
  end

  def index
    respond_to do |format|
      format.html {collection}
      format.csv do
        csv_string = CSV.generate do |csv|
          # header row
          csv << ["name", "moip", "goal", "reached", "moip_tax", "catarse_fee", "repass_value","expires_at", "backer_report", "state"]
          # data rows
          projects.each do |project|
            catarse_fee = ::Configuration[:catarse_fee].to_f * project.pledged
            csv << [project.name,
                    project.user.moip_login,
                    project.display_goal,
                    "#{project.display_pledged} (#{project.progress}%)",
                    "#{view_context.number_to_currency project.total_payment_service_fee, precision: 2 }",
                    "#{view_context.number_to_currency catarse_fee, precision: 2 } (#{view_context.number_to_currency project.pledged - catarse_fee, precision: 2 })",
                    "#{view_context.number_to_currency project.pledged*0.87, precision: 2 }",
                     "#{project.display_expires_at} (#{I18n.l(8.weekdays_from(project.expires_at).to_date)})",
                     "#{adm_reports_backer_reports_url(project_id: project.id, format: :csv)}",
                     project.state
            ]
          end
        end
        send_data csv_string,
                  type: 'text/csv; charset=iso-8859-1; header=present',
                  disposition: "attachment; filename=financials.csv"
      end
    end
  end

end

_ALLREPOS/jondeame/app/controllers/adm/projects_controller.rb
class Adm::ProjectsController < Adm::BaseController
  menu I18n.t("adm.projects.index.menu") => Rails.application.routes.url_helpers.adm_projects_path

  has_scope :by_id, :pg_search, :user_name_contains, :by_state
  has_scope :between_created_at, using: [ :start_at, :ends_at ], allow_blank: true
  has_scope :order_table, default: 'created_at'

  before_filter do
    @total_projects = Project.count
  end

  [:approve, :reject, :push_to_draft].each do |name|
    define_method name do
      @project = Project.find params[:id]
      @project.send("#{name.to_s}!")
      redirect_to :back
    end
  end

  def destroy
    @project = Project.find params[:id]
    if @project.can_push_to_trash?
      @project.push_to_trash!
    end

    redirect_to adm_projects_path
  end

  def collection
    @projects = apply_scopes(end_of_association_chain).not_deleted_projects.page(params[:page])
  end
end

_ALLREPOS/jondeame/app/controllers/adm/reports/backer_reports_controller.rb
class Adm::Reports::BackerReportsController < Adm::Reports::BaseController
  def end_of_association_chain
    super.where(project_id: params[:project_id])
  end
end

_ALLREPOS/jondeame/app/controllers/adm/reports/base_controller.rb
class Adm::Reports::BaseController < Adm::BaseController
  inherit_resources
  responders :csv
  respond_to :csv
  actions :index
end

_ALLREPOS/jondeame/app/controllers/adm/statistics_controller.rb
class Adm::StatisticsController < Adm::BaseController
  inherit_resources
  defaults  resource_class: Statistics
  menu I18n.t("adm.statistics.index.menu") => Rails.application.routes.url_helpers.adm_statistics_path
  actions :index
end

_ALLREPOS/jondeame/app/controllers/adm/users_controller.rb
class Adm::UsersController < Adm::BaseController
  inherit_resources
  menu I18n.t("adm.users.index.menu") => Rails.application.routes.url_helpers.adm_users_path
  before_filter :set_title
  before_filter :set_totals

  has_scope :by_id, :by_name, :by_email, :by_payer_email, :by_key, :has_credits, :has_credits_difference, only: :index

  protected
  def set_totals
    totals = end_of_association_chain.backer_totals
    @total_users = totals[:users].to_i
    @total_backs = totals[:backs]
    @total_backed = totals[:backed]
    @total_credits = totals[:credits]
  end

  def set_title
    @title = t("adm.users.index.title")
  end

  def collection
    @users ||= apply_scopes(end_of_association_chain).order_by(params[:order_by] || 'coalesce(user_totals.sum, 0) DESC').includes(:user_total).page(params[:page])
  end
end

_ALLREPOS/jondeame/app/controllers/channels/adm/projects_controller.rb
class Channels::Adm::ProjectsController < Adm::BaseController
  menu I18n.t('channels.adm.menu') => Rails.application.routes.url_helpers.adm_projects_path

  
  has_scope :by_id, :pg_search, :user_name_contains, :order_table, :by_state
  has_scope :between_created_at, using: [ :start_at, :ends_at ], allow_blank: true
  has_scope :order_table do |controller, scope, value|
  value.present? ? scope.order_table(value) : scope.order('created_at DESC')
  end



  before_filter do
    @channel        =  Channel.find_by_permalink!(request.subdomain.to_s)
    @total_projects =  @channel.projects.size 
  end

  [:approve, :reject, :push_to_draft].each do |name|
    define_method name do
      @project    = @channel.projects.find(params[:id])
      @project.send("#{name.to_s}!")
      redirect_to :back
    end
  end

  protected
    def begin_of_association_chain
      @channel
    end

    def collection
      @projects = apply_scopes(@channel.projects.page(params[:page]))
    end
  

end

_ALLREPOS/jondeame/app/controllers/channels/projects_controller.rb
class Channels::ProjectsController < ProjectsController
  belongs_to :channel, finder: :find_by_permalink!, param: :profile_id


  # Inheriting from the original Projects controller
  # With one addition: we include the project into the current channel
  before_filter only: [:create] { params[:project][:channels] = [@channel] }
  after_filter only: [:create] { notify_trustees }

  prepend_before_filter{ params[:profile_id] = request.subdomain }




  # After a project submission through a channel, notify all channel's trustees
  protected
    def notify_trustees

    end
end

_ALLREPOS/jondeame/app/controllers/projects/backers_controller.rb
class Projects::BackersController < ApplicationController
  inherit_resources
  actions :index, :show, :new, :update_info, :review, :create
  skip_before_filter :force_http, only: [:create, :update_info]
  skip_before_filter :verify_authenticity_token, only: [:moip]
  load_and_authorize_resource
  belongs_to :project

  def update_info
    resource.update_attributes(params[:backer])
    render json: {message: 'updated'}
  end

  def index
    @backers = parent.backers.available_to_count.order("confirmed_at DESC").page(params[:page]).per(10)
    render @backers
  end

  def show
    @title = t('projects.backers.show.title')
    session[:thank_you_backer_id] = nil
  end

  def new
    unless parent.online?
      flash[:failure] = t('projects.back.cannot_back')
      return redirect_to :root
    end

    @create_url = ::Configuration[:secure_review_host] ?
      project_backers_url(@project, {host: ::Configuration[:secure_review_host], protocol: 'https'}) :
      project_backers_path(@project)

    @title = t('projects.backers.new.title', name: @project.name)
    @backer = @project.backers.new(user: current_user)
    empty_reward = Reward.new(minimum_value: 0, description: t('projects.backers.new.no_reward'))
    @rewards = [empty_reward] + @project.rewards.order(:minimum_value)

    # Select 
    if params[:reward_id] && (@selected_reward = @project.rewards.find params[:reward_id]) && !@selected_reward.sold_out?
      @backer.reward = @selected_reward
      @backer.value = "%0.0f" % @selected_reward.minimum_value
    end
  end

  def create
    @title = t('projects.backers.create.title')
    @backer.user = current_user
    @backer.reward_id = nil if params[:backer][:reward_id].to_i == 0
    create! do |success,failure|
      failure.html do
        flash[:failure] = t('projects.backers.review.error')
        return redirect_to new_project_backer_path(@project)
      end
      success.html do
        session[:thank_you_backer_id] = @backer.id
        return render :create
      end
    end
    @thank_you_id = @project.id
  end

  def credits_checkout
    if current_user.credits < @backer.value
      flash[:failure] = t('projects.backers.checkout.no_credits')
      return redirect_to new_project_backer_path(@backer.project)
    end

    unless @backer.confirmed?
      @backer.update_attributes({ payment_method: 'Credits' })
      @backer.confirm!
    end
    flash[:success] = t('projects.backers.checkout.success')
    redirect_to project_backer_path(project_id: parent.id, id: resource.id)
  end
end

_ALLREPOS/jondeame/app/controllers/projects/updates_controller.rb
class Projects::UpdatesController < ApplicationController
  inherit_resources
  load_and_authorize_resource

  actions :index, :create, :destroy
  belongs_to :project

  def show
    render resource
  end

  def index
    render end_of_association_chain.page(params[:page]).per(3)
  end

  def create
    @update = parent.updates.create(params[:update].merge!(user: current_user))
    render @update
  end

  def destroy
    destroy!{|format| return index }
  end
end

_ALLREPOS/jondeame/app/controllers/users/projects_controller.rb
class Users::ProjectsController < ApplicationController
  inherit_resources
  actions :index
  belongs_to :user

  def index
    render layout: false
  end

  def collection
    @projects ||= end_of_association_chain.page(params[:page]).per(10)
  end
end

_ALLREPOS/jondeame/app/views/adm/projects/index.html.slim
#page_content
  .container
    .title
      h1= t('.title')
      h2
        strong= "#{@total_projects} "
        = t('.total_projects')

    .filters
      .bootstrap-form
        = form_tag adm_projects_path, method: :get, class: 'form-horizontal' do |f|
          fieldset
            .input
              = label_tag :by_id, t('.id')
              = text_field_tag :by_id, params[:by_id], class: 'input-small'

            .input
              = label_tag :between_created_at_start_at, t('.between_created_at')
              = text_field_tag 'between_created_at[start_at]', (params[:between_created_at][:start_at] if params[:between_created_at].present?), class: 'input-small'
              | &nbsp;
              | &nbsp;
              = text_field_tag 'between_created_at[ends_at]', (params[:between_created_at][:ends_at] if params[:between_created_at].present?), class: 'input-small'

            .input
              = label_tag :by_state, t('.by_state')
              = select_tag :by_state, options_for_select(Project.state_names, params[:by_state]), include_blank: true

            .input
              = label_tag :pg_search, t('.project')
              = text_field_tag :pg_search, params[:pg_search]
            .input
              = label_tag :user_name_contains, t('.user')
              = text_field_tag :user_name_contains, params[:user_name_contains]
            .input
              = label_tag :order_table, t('.order_table')
              = select_tag :order_table, options_for_select({t('.order_created_at') => 'created_at', t('.order_asc') => 'asc',t('.order_desc') => 'desc'}, params[:order_table]), include_blank: false

            .bootstrap-twitter
              .input.submit
                = submit_tag t('.submit'), class: 'btn btn-success'
          fieldset
            .input.total_results
              #total_results
                = pluralize_without_number @projects.count, t('found_singular'), t('found_plural')
                strong= @projects.count
                = pluralize_without_number(@projects.count, t('project_singular'), t('project_plural')).downcase
      .clearfix
    .data-table
      = paginate @projects
      - if @projects.empty?
        = t('.no_backers')
      - else
        .bootstrap-twitter
          table.table.table-striped
            thead
              tr
                th style="width: 200px;"
                  = t('.name')
                th= t('.category')
                th= t('.user_id')
                th= t('.goal')
                th= t('.pledged')
                th= t('.total_backs')
                th= t('.recommended')
                th= t('.online_date')
                th= t('.expires_at')
                th= t('.state')
                th
            tbody
              - @projects.includes(:category).each do |project|
                tr id=project.id class=cycle("even", "odd")
                  td= link_to project.name, project_by_slug_path(permalink: project.permalink)
                  td= project.category
                  td= best_in_place [:adm, project], :user_id, method: :put, type: :input
                  td= best_in_place [:adm, project], :goal, method: :put, type: :input, display_as: :display_goal
                  td= "#{project.display_pledged} (#{project.progress}%)"
                  td= project.total_backers
                  td.checkbox= best_in_place [:adm, project], :recommended, method: :put, type: :checkbox, collection: [t('no'), t('yes')]
                  td= project.online_date.strftime('%d/%m/%Y') if project.online_date
                  td= project.display_expires_at
                  td
                    - if project.online?
                      span.label.label-online= project.state
                    - elsif project.successful?
                      span.label.label-success= project.state
                    - elsif project.failed? or project.rejected?
                      span.label.label-important= project.state
                    - elsif project.waiting_funds?
                      span.label.label-warning= project.state
                    - else
                      span.label= project.state
                  td
                    .btn-group
                      = link_to 'javascript:void(0);', class: 'btn btn-mini dropdown-toggle', data: {toggle: "dropdown"} do
                        b.caret
                      ul.dropdown-menu
                        - if project.can_push_to_trash?
                          li
                            = link_to adm_project_path(project), method: :delete, data: {confirm: t('adm.confirm_dialog')} do
                              i.icon-trash
                              = t('.send_to_trash')
                        - if project.can_approve?
                          li
                            = link_to approve_adm_project_path(project), method: :put do
                              i.icon-ok
                              = t('.approve')

                        - if project.can_reject?
                          li
                            = link_to reject_adm_project_path(project), method: :put  do
                              i.icon-ban-circle
                              = t('.reject')

                        - if project.can_push_to_draft?
                          li
                            = link_to  push_to_draft_adm_project_path(project), method: :put  do
                              i.icon-trash
                              = t('.send_to_draft')
      = paginate @projects
  .clearfix